#include "include/windows_nt_user/windows_nt_user_plugin.h"

// This must be included before many other Windows headers.
#include <windows.h>

// For getPlatformVersion; remove unless needed for your plugin implementation.
#include <VersionHelpers.h>

#include <flutter/method_channel.h>
#include <flutter/plugin_registrar_windows.h>
#include <flutter/standard_method_codec.h>

#include <map>
#include <memory>
#include <sstream>

#include <windows.h>
#include <Lmcons.h>
#include <iostream>
#include <atlstr.h>
using namespace std; 

#ifndef _UNICODE
#define _UNICODE
#define UNICODE
#endif

#define WIN32_LEAN_AND_MEAN
#include <Windows.h>

#define SECURITY_WIN32
#include <Security.h>
#pragma comment(lib, "Secur32.lib")

namespace {

class WindowsNtUserPlugin : public flutter::Plugin {
 public:
  static void RegisterWithRegistrar(flutter::PluginRegistrarWindows *registrar);

  WindowsNtUserPlugin();

  virtual ~WindowsNtUserPlugin();

 private:
  // Called when a method is called on this plugin's channel from Dart.
  void HandleMethodCall(
      const flutter::MethodCall<flutter::EncodableValue> &method_call,
      std::unique_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
};

// static
void WindowsNtUserPlugin::RegisterWithRegistrar(
    flutter::PluginRegistrarWindows *registrar) {
  auto channel =
      std::make_unique<flutter::MethodChannel<flutter::EncodableValue>>(
          registrar->messenger(), "windows_nt_user",
          &flutter::StandardMethodCodec::GetInstance());

  auto plugin = std::make_unique<WindowsNtUserPlugin>();

  channel->SetMethodCallHandler(
      [plugin_pointer = plugin.get()](const auto &call, auto result) {
        plugin_pointer->HandleMethodCall(call, std::move(result));
      });

  registrar->AddPlugin(std::move(plugin));
}

WindowsNtUserPlugin::WindowsNtUserPlugin() {}

WindowsNtUserPlugin::~WindowsNtUserPlugin() {}


void WindowsNtUserPlugin::HandleMethodCall(
    const flutter::MethodCall<flutter::EncodableValue> &method_call,
    std::unique_ptr<flutter::MethodResult<flutter::EncodableValue>> result) {
 if(method_call.method_name().compare("getNTUser") == 0) {
    // Function to get Windows NT User 
    LPWSTR acUserName  = new TCHAR[UNLEN + 1];
    DWORD nUserName = UNLEN + 1;
    if (GetUserName(acUserName, &nUserName)) {
      string NTUser = CW2A(acUserName);
      result->Success(flutter::EncodableValue(NTUser));
    }
    else { 
      result->Success(flutter::EncodableValue("Name not found"));
    }
     
  } else if (method_call.method_name().compare("getFullUsername") == 0) {
    // Function to Get Windows Full Username
    EXTENDED_NAME_FORMAT eNameDisplay = NameDisplay;
	  const DWORD Len = 1024;
	  // TCHAR szUsername[Len + 1];
	  LPWSTR szUsername  = new TCHAR[UNLEN + 1];
    DWORD dwLen = Len;

	  if (GetUserNameExW(eNameDisplay, szUsername, &dwLen))
	  {
      string UserName = CW2A(szUsername);
		  result->Success(flutter::EncodableValue(UserName));
	  } else {
      result->Success(flutter::EncodableValue("Name not found"));
    }
  } else {
    // If Not Implemented
    result->NotImplemented();
  }
}

}  // namespace

void WindowsNtUserPluginRegisterWithRegistrar(
    FlutterDesktopPluginRegistrarRef registrar) {
  WindowsNtUserPlugin::RegisterWithRegistrar(
      flutter::PluginRegistrarManager::GetInstance()
          ->GetRegistrar<flutter::PluginRegistrarWindows>(registrar));
}
